support `@arguments.rst` for args through file

This commit is contained in:
WebFreak001 2023-09-24 14:30:43 +02:00 committed by Jan Jurzitza
parent a958f9ac7b
commit 6491d792f5
5 changed files with 61 additions and 18 deletions

View File

@ -5,20 +5,21 @@
module dscanner.main;
import std.algorithm;
import std.array;
import std.conv;
import std.file;
import std.getopt;
import std.path;
import std.stdio;
import std.range;
import std.experimental.lexer;
import std.typecons : scoped;
import std.functional : toDelegate;
import dparse.lexer;
import dparse.parser;
import dparse.rollback_allocator;
import std.algorithm;
import std.array;
import std.conv;
import std.experimental.lexer;
import std.file;
import std.functional : toDelegate;
import std.getopt;
import std.path;
import std.range;
import std.stdio;
import std.string : chomp, splitLines;
import std.typecons : scoped;
import dscanner.highlighter;
import dscanner.stats;
@ -75,6 +76,9 @@ else
bool verbose;
string errorFormat;
if (args.length == 2 && args[1].startsWith("@"))
args = args[0] ~ readText(args[1][1 .. $]).chomp.splitLines;
try
{
// dfmt off

View File

@ -1,7 +1,7 @@
; Configure which static analysis checks are enabled
[analysis.config.StaticAnalysisConfig]
; Check variable, class, struct, interface, union, and function names against the Phobos style guide
style_check="disabled"
style_check="enabled"
; Check for array literals that cause unnecessary allocation
enum_array_literal_check="enabled"
; Check for poor exception handling practices

View File

@ -2,8 +2,37 @@
set -eu -o pipefail
function section {
e=$'\e'
if [ ! -z "${GITHUB_ACTION:-}" ]; then
echo "::endgroup::"
fi
if [ ! -z "${GITHUB_ACTION:-}" ]; then
echo "::group::$@"
fi
echo "$e[1m$@$e[m"
}
function error {
echo $'\e[31;1mTests have failed.\e[m'
exit 1
}
function cleanup {
if [ ! -z "${GITHUB_ACTION:-}" ]; then
echo "::endgroup::"
fi
}
DSCANNER_DIR="$(dirname -- $( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && pwd ))"
if [ ! -z "${GITHUB_ACTION:-}" ]; then
echo "::group::Building d-scanner"
fi
trap cleanup EXIT
trap error ERR
if [ -z "${CI:-}" ]; then
dub build --root="$DSCANNER_DIR"
fi
@ -19,28 +48,36 @@ diff <(../bin/dscanner --resolveMessage b16 it/autofix_ide/source_autofix.d | jq
# CLI tests
# ---------
# check that `dscanner fix` works as expected
echo '1. test no changes if EOFing'
section '1. test no changes if EOFing'
cp -v it/autofix_cli/source.d it/autofix_cli/test.d
printf "" | ../bin/dscanner fix it/autofix_cli/test.d
diff it/autofix_cli/test.d it/autofix_cli/source.d
echo '2. test no changes for simple enter pressing'
section '2. test no changes for simple enter pressing'
cp -v it/autofix_cli/source.d it/autofix_cli/test.d
printf "\n" | ../bin/dscanner fix it/autofix_cli/test.d
diff it/autofix_cli/test.d it/autofix_cli/source.d
echo '2.1. test no changes entering 0'
section '2.1. test no changes entering 0'
cp -v it/autofix_cli/source.d it/autofix_cli/test.d
printf "0\n" | ../bin/dscanner fix it/autofix_cli/test.d
diff it/autofix_cli/test.d it/autofix_cli/source.d
echo '3. test change applies automatically with --applySingle'
section '3. test change applies automatically with --applySingle'
cp -v it/autofix_cli/source.d it/autofix_cli/test.d
../bin/dscanner fix --applySingle it/autofix_cli/test.d | grep -F 'Writing changes to it/autofix_cli/test.d'
diff it/autofix_cli/test.d it/autofix_cli/fixed.d
echo '4. test change apply when entering "1"'
section '4. test change apply when entering "1"'
cp -v it/autofix_cli/source.d it/autofix_cli/test.d
printf "1\n" | ../bin/dscanner fix it/autofix_cli/test.d | grep -F 'Writing changes to it/autofix_cli/test.d'
diff it/autofix_cli/test.d it/autofix_cli/fixed.d
echo '5. test invalid selection reasks what to apply'
section '5. test invalid selection reasks what to apply'
cp -v it/autofix_cli/source.d it/autofix_cli/test.d
printf "2\n-1\n1000\na\n1\n" | ../bin/dscanner fix it/autofix_cli/test.d | grep -F 'Writing changes to it/autofix_cli/test.d'
diff it/autofix_cli/test.d it/autofix_cli/fixed.d
# check that `dscanner @myargs.rst` reads arguments from file
section "Test @myargs.rst"
echo "-f" > "myargs.rst"
echo "github" >> "myargs.rst"
echo "lint" >> "myargs.rst"
echo "it/singleissue.d" >> "myargs.rst"
diff it/singleissue_github.txt <(../bin/dscanner "@myargs.rst")
rm "myargs.rst"

1
tests/it/singleissue.d Normal file
View File

@ -0,0 +1 @@
int NonMatchingName;

View File

@ -0,0 +1 @@
::warning file=it/singleissue.d,line=1,endLine=1,col=5,endColumn=20,title=Warning (style_check)::Variable name 'NonMatchingName' does not match style guidelines.